/*******************************************************************************
 FILE : KMAILDLL.h

  (c) Copyright 2003-2004 kissy
*******************************************************************************/
#ifndef _KMAILDLL_H_
#define _KMAILDLL_H_

#ifdef __cplusplus
#define DLLEXPORT extern "C" __declspec (dllexport)
#else 
#define DLLEXPORT __declspec (dllexport)
#endif

/* Type define */
typedef HANDLE	MAIL_HANDLE;
typedef DWORD (__stdcall *KMAIL_Callback)(WPARAM wParam, LPARAM lParam);

/* Parameter of POP3 callback function */
typedef struct tagTPOP3FileList {
	UINT uiID;				/* mail number of pop3 server */
	LPCTSTR pszFileName;	/* filename of recieved mail  */
} TPOP3FileList;

typedef struct tagTPOP3RetParam {
	UINT uiSize;			/* size of structure          */
	UINT uiNum;				/* number of mail             */
	TPOP3FileList *filelist;
} TPOP3RetParam;

/* Parameter of SMTP callback function */
typedef struct tagTSMTPRetParam {
	UINT uiSize;			/* size of structure            */
	BYTE bRetCmd;			/* id of command returned code  */
	BYTE bRetCode;			/* returned code                */
} TSMTPRetParam;

#define SMTP_RETCMD_CONNECT		0
#define SMTP_RETCMD_ATRN		1
#define SMTP_RETCMD_AUTH		2
#define SMTP_RETCMD_BDAT		3
#define SMTP_RETCMD_DATA		4
#define SMTP_RETCMD_EHLO		5
#define SMTP_RETCMD_ETRN		6
#define SMTP_RETCMD_EXPN		7
#define SMTP_RETCMD_HELO		8
#define SMTP_RETCMD_HELP		9
#define SMTP_RETCMD_MAIL		10
#define SMTP_RETCMD_NOOP		11
#define SMTP_RETCMD_QUIT		12
#define SMTP_RETCMD_RCPT		13
#define SMTP_RETCMD_RSET		14
#define SMTP_RETCMD_SAML		15
#define SMTP_RETCMD_SEND		16
#define SMTP_RETCMD_SOML		17
#define SMTP_RETCMD_STLS		18		/* STARTTLS-TLS */
#define SMTP_RETCMD_TURN		19
#define SMTP_RETCMD_VRFY		20
#define SMTP_RETCMD_DISCONNECT	21

/* Basic export function */
DLLEXPORT DWORD WINAPI GetDllVersion();
DLLEXPORT WORD WINAPI GetDllDetailVersion();
DLLEXPORT INT WINAPI KMAIL_Initialize();
DLLEXPORT INT WINAPI KMAIL_Terminate();

/* POP3 export function */
DLLEXPORT BOOL WINAPI KMAIL_POP3Connect(LPCSTR pszPOP3Server, WORD wPort, KMAIL_Callback fncCallback);
DLLEXPORT BOOL WINAPI KMAIL_POP3Certification(LPCSTR pszUserName, LPCSTR pszPassword, KMAIL_Callback fncCallback);
DLLEXPORT BOOL WINAPI KMAIL_POP3GetAllMail(KMAIL_Callback fncCallback);
DLLEXPORT BOOL WINAPI KMAIL_POP3GetMail(DWORD dwID, KMAIL_Callback fncCallback);
DLLEXPORT DWORD WINAPI KMAIL_POP3GetMailList(KMAIL_Callback fncCallback);
DLLEXPORT BOOL WINAPI KMAIL_POP3DeleteAllMail(KMAIL_Callback fncCallback);
DLLEXPORT BOOL WINAPI KMAIL_POP3DeleteMail(DWORD dwID, KMAIL_Callback fncCallback);
DLLEXPORT BOOL WINAPI KMAIL_POP3Quit(KMAIL_Callback fncCallback);
DLLEXPORT BOOL WINAPI KMAIL_POP3Disconnect(KMAIL_Callback fncCallback);

/* SMTP export function */
DLLEXPORT BOOL WINAPI KMAIL_SMTPConnect(LPCSTR pszSMTPServer, WORD wPort, KMAIL_Callback fncCallback);
DLLEXPORT MAIL_HANDLE WINAPI KMAIL_SMTPNewMail();
DLLEXPORT BOOL WINAPI KMAIL_SMTPSetSubject(MAIL_HANDLE hMail, LPCTSTR pszSubject);
DLLEXPORT BOOL WINAPI KMAIL_SMTPSetFrom(MAIL_HANDLE hMail, LPCTSTR pszName, LPCTSTR pszFrom);
DLLEXPORT BOOL WINAPI KMAIL_SMTPAddTo(MAIL_HANDLE hMail, LPCTSTR pszName, LPCTSTR pszTo);
DLLEXPORT BOOL WINAPI KMAIL_SMTPAddCc(MAIL_HANDLE hMail, LPCTSTR pszName, LPCTSTR pszCc);
DLLEXPORT BOOL WINAPI KMAIL_SMTPAddBcc(MAIL_HANDLE hMail, LPCTSTR pszName, LPCTSTR pszBcc);
DLLEXPORT BOOL WINAPI KMAIL_SMTPSetBody(MAIL_HANDLE hMail, LPCTSTR pszBody);
DLLEXPORT BOOL WINAPI KMAIL_SMTPAddBody(MAIL_HANDLE hMail, LPCTSTR pszBody);
DLLEXPORT BOOL WINAPI KMAIL_SMTPAddAttach(MAIL_HANDLE hMail, LPCTSTR pszAttachPath, LPCSTR pszContentType);
DLLEXPORT BOOL WINAPI KMAIL_SMTPSendMail(MAIL_HANDLE hMail, KMAIL_Callback fncCallback);
DLLEXPORT BOOL WINAPI KMAIL_SMTPQuit(KMAIL_Callback fncCallback);
DLLEXPORT BOOL WINAPI KMAIL_SMTPDisconnect(KMAIL_Callback fncCallback);

#endif /* _KMAILDLL_H_ */
