///////////////////////////////////////////////////////////////////////////////
// FILE : MIME_ContentType.h
//
// (c) Copyright 2003-2004 kissy
///////////////////////////////////////////////////////////////////////////////
#ifndef _MIME_ContentType.h_
#define _MIME_ContentType.h_

#define CONTENT_TYPE_NONE				0xFFFFFFFF	// content type not use

/* --- Top level content-type --- */
#define	CONTENT_TOP_TEXT				0x00000001	// text
#define	CONTENT_TOP_IMAGE				0x00000002	// image
#define	CONTENT_TOP_AUDIO				0x00000004	// audio
#define CONTENT_TOP_VIDEO				0x00000008	// video
#define CONTENT_TOP_APPLICATION			0x00000010	// application
#define	CONTENT_TOP_MULTI				0x00000100	// multipart
#define	CONTENT_TOP_MESSAGE				0x00000200	// message

/* - Text sub content-type - */
#define	CONTENT_TEXT_SUB_PLAIN			0x00000001	// text/plain
#define CONTENT_TEXT_SUB_HTML			0x00000002	// text/html
#define CONTENT_TEXT_SUB_XVCARD			0x00000004	// text/x-vcard

/* - Image sub content-type - */
#define	CONTENT_IMAGE_SUB_JPEG			0x00000001	// image/jpeg
#define CONTENT_IMAGE_SUB_GIF			0x00000002	// image/gif
#define CONTENT_IMAGE_SUB_BMP			0x00000004	// image/bmp
#define CONTENT_IMAGE_SUB_PNG			0x00000008	// image/png
#define CONTENT_IMAGE_SUB_TIFF			0x00000010	// image/tiff
#define CONTENT_IMAGE_SUB_XBM			0x00000020	// image/xbm
#define CONTENT_IMAGE_SUB_XPM			0x00000040	// image/xpm

/* - Audio sub content-type - */
#define	CONTENT_AUDIO_SUB_BASIC			0x00000001	// audio/basic
#define CONTENT_AUDIO_SUB_MIDI			0x00000002	// audio/midi
#define	CONTENT_AUDIO_SUB_MP3			0x00000004	// audio/mp3
#define CONTENT_AUDIO_SUB_WAVE			0x00000008	// audio/wave
#define CONTENT_AUDIO_SUB_XAIFF			0x00000010	// audio/x-aiff
#define CONTENT_AUDIO_SUB_XRA			0x00000020	// audio/x-pn-realaudio

/* - Video sub content-type - */
#define	CONTENT_VIDEO_SUB_MPEG			0x00000001	// video/mpeg
#define CONTENT_VIDEO_SUB_AVI			0x00000002	// video/avi
#define CONTENT_VIDEO_SUB_QT			0x00000004	// video/quicktime

/* - Application sub content-type - */
#define	CONTENT_APP_SUB_OCTET			0x00000001	// application/octet-stream
#define CONTENT_APP_SUB_GZIP			0x00000002	// application/gzip
#define CONTENT_APP_SUB_SIT				0x00000004	// application/sit
#define CONTENT_APP_SUB_TAR				0x00000008	// application/tar
#define CONTENT_APP_SUB_ZIP				0x00000010	// application/x-zip-compressed
#define CONTENT_APP_SUB_HQX				0x00000020	// application/mac-binhex40
#define CONTENT_APP_SUB_PS				0x00000040	// application/postscript
#define CONTENT_APP_SUB_RTF				0x00000080	// application/rtf
#define CONTENT_APP_SUB_STUFFIT			0x00000100	// application/x-stuffit
#define CONTENT_APP_SUB_UUE				0x00000200	// application/x-uuencode

/* - Multipart sub content-type - */
#define CONTENT_MULTI_SUB_MIXED			0x00000001	// multipart/mixed
#define CONTENT_MULTI_SUB_ALTERNATIVE	0x00000002	// multipart/alternative
#define CONTENT_MULTI_SUB_PARALLEL		0x00000004	// multipart/parallel
#define CONTENT_MULTI_SUB_DIGEST		0x00000008	// multipart/digest

/* - Message sub content-type - */
#define CONTENT_MSG_SUB_RFC822			0x0000001	// message/rfc822
#define CONTENT_MSG_SUB_PARTIAL			0x0000002	// message/partial
#define CONTENT_MSG_SUB_EXBODY			0x0000004	// message/external-body

#endif /* _MIME_ContentType.h_ */
